#property copyright "Copyright  2007, Financial Resource Group"
#property link      "mail@metatraderexpertadvisors.com"

extern string GeneralSettings = "---------- General Settings";
extern int MagicNumber = 782;
extern int Slippage = 6;
extern string Indi_Parameters = "---------- Indicator Settings";
extern int FastMAPeriod = 5;
extern int FastMAType = 1;
extern int FastMAPrice = 0;
extern int FastMAshift = 0;
extern int SlowMAPeriod = 20;
extern int SlowMAType = 1;
extern int SlowMAPrice = 0;
extern int SlowMAshift = 0;
extern int SlowMAPipPad = 5;
extern string TMSettings = "----------Trade Management";
extern bool OneEntryPerBar = TRUE;
extern bool EnterOnBarClose = FALSE;
extern bool MACrossClosePosition = TRUE;
extern int CloseOrderPipPad = 5;
extern double Lots = 1.0;
extern int Initial_StopLoss = 0;
extern int Initial_TakeProfit = 0;
extern int ModifyAfterPipProfit = 0;
extern int ModifySL = 0;
extern int ModifyTP = 0;
extern int InitialTS = 0;
extern int ModifyTSAfterPipProfit = 0;
extern int ModifyTS = 0;
extern bool UseTradeTime = TRUE;
extern string TradeTimeStart = "12:00";
extern string TradeTimeEnd = "18:30";
extern bool TimeClose = TRUE;
extern string CloseTime = "21:30";
int gi_232 = 10;
int g_datetime_236;

int init() {
   WriteMABuy(0);
   WriteMASell(0);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int l_ord_total_24;
   double l_ima_32;
   double l_ima_40;
   double l_ima_48;
   double l_ima_56;
   string ls_0 = "2010.11.01";
   int l_str2time_8 = StrToTime(ls_0);
   if (TimeCurrent() >= l_str2time_8) {
      Alert("Expired. Go to www.metatraderexpertadvisors.com/renew");
      return (0);
   }
   int li_12 = 0;
   int l_hour_16 = TimeHour(StrToTime(CloseTime));
   int l_minute_20 = TimeMinute(StrToTime(CloseTime));
   if (TimeClose) {
      if (Hour() == l_hour_16 && Minute() >= l_minute_20) {
         if (subTotalTrade() > 0) subCloseOrder();
         return (0);
      }
   }
   if (ModifyAfterPipProfit > 0 && subTotalTrade() > 0) {
      l_ord_total_24 = OrdersTotal();
      for (int l_pos_28 = 0; l_pos_28 < l_ord_total_24; l_pos_28++) {
         OrderSelect(l_pos_28, SELECT_BY_POS, MODE_TRADES);
         if (OrderType() <= OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) subModifyOrder(OrderType(), ModifyAfterPipProfit, ModifyTP, ModifySL);
      }
   }
   if (InitialTS > 0 || ModifyTS > 0 && subTotalTrade() > 0) {
      l_ord_total_24 = OrdersTotal();
      for (l_pos_28 = 0; l_pos_28 < l_ord_total_24; l_pos_28++) {
         OrderSelect(l_pos_28, SELECT_BY_POS, MODE_TRADES);
         if (OrderType() <= OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
            subInitialTrailingStop(OrderType(), ModifyTSAfterPipProfit, InitialTS);
            subModTrailingStop(OrderType(), ModifyTSAfterPipProfit, ModifyTS);
         }
      }
   }
   if (EnterOnBarClose) {
      l_ima_32 = iMA(Symbol(), 0, FastMAPeriod, FastMAshift, FastMAType, FastMAPrice, 1);
      l_ima_40 = iMA(Symbol(), 0, SlowMAPeriod, SlowMAshift, SlowMAType, SlowMAPrice, 1);
      l_ima_48 = iMA(Symbol(), 0, FastMAPeriod, FastMAshift, FastMAType, FastMAPrice, 2);
      l_ima_56 = iMA(Symbol(), 0, SlowMAPeriod, SlowMAshift, SlowMAType, SlowMAPrice, 2);
   }
   if (!EnterOnBarClose) {
      l_ima_32 = iMA(Symbol(), 0, FastMAPeriod, FastMAshift, FastMAType, FastMAPrice, 0);
      l_ima_40 = iMA(Symbol(), 0, SlowMAPeriod, SlowMAshift, SlowMAType, SlowMAPrice, 0);
      l_ima_48 = iMA(Symbol(), 0, FastMAPeriod, FastMAshift, FastMAType, FastMAPrice, 1);
      l_ima_56 = iMA(Symbol(), 0, SlowMAPeriod, SlowMAshift, SlowMAType, SlowMAPrice, 1);
   }
   if (l_ima_48 < l_ima_56 && subTotalTrade() < 1) WriteMABuy(1);
   if (l_ima_48 > l_ima_56 && subTotalTrade() < 1) WriteMASell(1);
   if (subTotalTrade() > 0 && MACrossClosePosition) {
      if (subTotalTypeOrders(OP_BUY) > 0) {
         if (l_ima_32 < l_ima_40 - CloseOrderPipPad * Point) {
            WriteMASell(1);
            subCloseOrder();
         }
      }
      if (subTotalTypeOrders(OP_SELL) > 0) {
         if (l_ima_32 > l_ima_40 + CloseOrderPipPad * Point) {
            WriteMABuy(1);
            subCloseOrder();
         }
      }
   }
   if (subTradingTime(UseTradeTime, TradeTimeStart, TradeTimeEnd) == "no") {
      Comment("None Trading Time");
      return (0);
   }
   Comment("TradeTime!");
   if (OneEntryPerBar) {
      if (subTotalTrade() < 1 && g_datetime_236 != iTime(Symbol(), 0, 0)) {
         if (ReadMABuy() == 1 && l_ima_32 > l_ima_40 + SlowMAPipPad * Point) {
            li_12 = subOpenOrder(0, Initial_StopLoss, Initial_TakeProfit, Lots);
            if (li_12 <= 0) li_12 = subOpenOrder(0, Initial_StopLoss, Initial_TakeProfit, Lots);
            if (li_12 <= 0) li_12 = subOpenOrder(0, Initial_StopLoss, Initial_TakeProfit, Lots);
            if (li_12 > 0) {
               g_datetime_236 = iTime(Symbol(), 0, 0);
               WriteMABuy(0);
            }
         }
         if (ReadMASell() == 1 && l_ima_32 < l_ima_40 - SlowMAPipPad * Point) {
            li_12 = subOpenOrder(1, Initial_StopLoss, Initial_TakeProfit, Lots);
            if (li_12 <= 0) li_12 = subOpenOrder(1, Initial_StopLoss, Initial_TakeProfit, Lots);
            if (li_12 <= 0) li_12 = subOpenOrder(1, Initial_StopLoss, Initial_TakeProfit, Lots);
            if (li_12 > 0) {
               g_datetime_236 = iTime(Symbol(), 0, 0);
               WriteMASell(0);
            }
         }
      }
   }
   if (!OneEntryPerBar) {
      if (subTotalTrade() < 1) {
         if (ReadMABuy() == 1 && l_ima_32 > l_ima_40 + SlowMAPipPad * Point) {
            li_12 = subOpenOrder(0, Initial_StopLoss, Initial_TakeProfit, Lots);
            if (li_12 <= 0) li_12 = subOpenOrder(0, Initial_StopLoss, Initial_TakeProfit, Lots);
            if (li_12 <= 0) li_12 = subOpenOrder(0, Initial_StopLoss, Initial_TakeProfit, Lots);
            if (li_12 > 0) {
               g_datetime_236 = iTime(Symbol(), 0, 0);
               WriteMABuy(0);
            }
         }
         if (ReadMASell() == 1 && l_ima_32 < l_ima_40 - SlowMAPipPad * Point) {
            li_12 = subOpenOrder(1, Initial_StopLoss, Initial_TakeProfit, Lots);
            if (li_12 <= 0) li_12 = subOpenOrder(1, Initial_StopLoss, Initial_TakeProfit, Lots);
            if (li_12 <= 0) li_12 = subOpenOrder(1, Initial_StopLoss, Initial_TakeProfit, Lots);
            if (li_12 > 0) {
               g_datetime_236 = iTime(Symbol(), 0, 0);
               WriteMASell(0);
            }
         }
      }
   }
   return (0);
}

int subTotalTrade() {
   int l_count_4 = 0;
   for (int l_pos_0 = 0; l_pos_0 < OrdersTotal(); l_pos_0++) {
      OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) l_count_4++;
   }
   return (l_count_4);
}

int subOpenOrder(int ai_0, int ai_4, int ai_8, double a_lots_12) {
   string l_comment_20 = "MAX1";
   int l_ticket_28 = 0;
   int l_error_32 = 0;
   int l_count_36 = 0;
   double l_price_40 = 0;
   double l_price_48 = 0;
   double l_price_56 = 0;
   double l_price_64 = 0;
   if (ai_4 != 0) {
      l_price_40 = NormalizeDouble(Ask - ai_4 * Point, 4);
      l_price_56 = NormalizeDouble(Bid + ai_4 * Point, 4);
   }
   if (ai_8 != 0) {
      l_price_48 = NormalizeDouble(Ask + ai_8 * Point, 4);
      l_price_64 = NormalizeDouble(Bid - ai_8 * Point, 4);
   }
   if (ai_0 == 0) {
      for (l_count_36 = 0; l_count_36 < gi_232; l_count_36++) {
         l_ticket_28 = OrderSend(Symbol(), OP_BUY, a_lots_12, Ask, Slippage, l_price_40, l_price_48, l_comment_20, MagicNumber, 0, Green);
         l_error_32 = GetLastError();
         if (l_error_32 == 0/* NO_ERROR */) {
            if (l_ticket_28 > 0) break;
         } else {
            if (l_error_32 == 0/* NO_ERROR */ || l_error_32 == 4/* SERVER_BUSY */ || l_error_32 == 136/* OFF_QUOTES */ || l_error_32 == 137/* BROKER_BUSY */ || l_error_32 == 138/* REQUOTE */ ||
               l_error_32 == 146/* TRADE_CONTEXT_BUSY */) Sleep(5000);
            else
               if (l_ticket_28 > 0) break;
         }
      }
   }
   if (ai_0 == 1) {
      for (l_count_36 = 0; l_count_36 < gi_232; l_count_36++) {
         l_ticket_28 = OrderSend(Symbol(), OP_SELL, a_lots_12, Bid, Slippage, l_price_56, l_price_64, l_comment_20, MagicNumber, 0, Red);
         l_error_32 = GetLastError();
         if (l_error_32 == 0/* NO_ERROR */) {
            if (l_ticket_28 > 0) break;
         } else {
            if (l_error_32 == 0/* NO_ERROR */ || l_error_32 == 4/* SERVER_BUSY */ || l_error_32 == 136/* OFF_QUOTES */ || l_error_32 == 137/* BROKER_BUSY */ || l_error_32 == 138/* REQUOTE */ ||
               l_error_32 == 146/* TRADE_CONTEXT_BUSY */) Sleep(5000);
            else
               if (l_ticket_28 > 0) break;
         }
      }
   }
   return (l_ticket_28);
}

void subModifyOrder(int ai_0, int ai_4, int ai_8, int ai_12) {
   if (ai_0 == 0) {
      if (Bid - OrderOpenPrice() > Point * ai_4) {
         if (OrderStopLoss() < NormalizeDouble(OrderOpenPrice() - Point * ai_12, Digits)) {
            OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - Point * ai_12, OrderTakeProfit(), 0, Green);
            return;
         }
         if (OrderTakeProfit() != NormalizeDouble(OrderOpenPrice() + Point * ai_8, Digits)) {
            OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), OrderOpenPrice() + Point * ai_8, 0, Green);
            return;
         }
      }
   }
   if (ai_0 == 1) {
      if (OrderOpenPrice() - Ask > Point * ai_4) {
         if (OrderStopLoss() > NormalizeDouble(OrderOpenPrice() + Point * ai_12, Digits)) {
            OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + Point * ai_12, OrderTakeProfit(), 0, Green);
            return;
         }
         if (OrderTakeProfit() != NormalizeDouble(OrderOpenPrice() - Point * ai_8, Digits)) {
            OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), OrderOpenPrice() - Point * ai_8, 0, Green);
            return;
         }
      }
   }
}

void subInitialTrailingStop(int ai_0, int ai_4, int ai_8) {
   if (ai_0 == 0) {
      if (Bid - OrderOpenPrice() <= Point * ai_4 && OrderStopLoss() < Bid - Point * ai_8) {
         OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * ai_8, OrderTakeProfit(), 0, Green);
         return;
      }
   }
   if (ai_0 == 1) {
      if (OrderOpenPrice() - Ask <= Point * ai_4) {
         if (OrderStopLoss() > Ask + Point * ai_8 || OrderStopLoss() == 0.0) {
            OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * ai_8, OrderTakeProfit(), 0, Red);
            return;
         }
      }
   }
}

void subModTrailingStop(int ai_0, int ai_4, int ai_8) {
   if (ai_0 == 0) {
      if (Bid - OrderOpenPrice() > Point * ai_4 && OrderStopLoss() < Bid - Point * ai_8) {
         OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * ai_8, OrderTakeProfit(), 0, Green);
         return;
      }
   }
   if (ai_0 == 1) {
      if (OrderOpenPrice() - Ask > Point * ai_4) {
         if (OrderStopLoss() > Ask + Point * ai_8 || OrderStopLoss() == 0.0) {
            OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * ai_8, OrderTakeProfit(), 0, Red);
            return;
         }
      }
   }
}

void subCloseOrder() {
   int l_ord_total_4 = 0;
   int l_ord_close_8 = 0;
   int l_error_12 = 0;
   int l_count_16 = 0;
   int li_20 = 10;
   l_ord_total_4 = OrdersTotal();
   for (int l_pos_0 = l_ord_total_4 - 1; l_pos_0 >= 0; l_pos_0--) {
      OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
         switch (OrderType()) {
         case OP_BUY:
            for (l_count_16 = 0; l_count_16 < li_20; l_count_16++) {
               l_ord_close_8 = OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Violet);
               l_error_12 = GetLastError();
               if (l_error_12 == 0/* NO_ERROR */) {
                  if (l_ord_close_8 > 0) break;
               } else {
                  if (l_error_12 == 0/* NO_ERROR */ || l_error_12 == 4/* SERVER_BUSY */ || l_error_12 == 136/* OFF_QUOTES */ || l_error_12 == 137/* BROKER_BUSY */ || l_error_12 == 138/* REQUOTE */ ||
                     l_error_12 == 146/* TRADE_CONTEXT_BUSY */) Sleep(5000);
                  else
                     if (l_ord_close_8 > 0) break;
               }
            }
            break;
         case OP_SELL:
            for (l_count_16 = 0; l_count_16 < li_20; l_count_16++) {
               l_ord_close_8 = OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, Violet);
               l_error_12 = GetLastError();
               if (l_error_12 == 0/* NO_ERROR */) {
                  if (l_ord_close_8 > 0) break;
               } else {
                  if (l_error_12 == 0/* NO_ERROR */ || l_error_12 == 4/* SERVER_BUSY */ || l_error_12 == 136/* OFF_QUOTES */ || l_error_12 == 137/* BROKER_BUSY */ || l_error_12 == 138/* REQUOTE */ ||
                     l_error_12 == 146/* TRADE_CONTEXT_BUSY */) Sleep(5000);
                  else
                     if (l_ord_close_8 > 0) break;
               }
            }
         }
      }
   }
}

int subTotalTypeOrders(int a_cmd_0) {
   int l_count_8 = 0;
   for (int l_pos_4 = 0; l_pos_4 < OrdersTotal(); l_pos_4++) {
      OrderSelect(l_pos_4, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() == a_cmd_0 && OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) l_count_8++;
   }
   return (l_count_8);
}

string subTradingTime(bool ai_0, string as_4, string as_12) {
   int l_hour_20 = TimeHour(StrToTime(as_4));
   int l_minute_24 = TimeMinute(StrToTime(as_4));
   int l_hour_28 = TimeHour(StrToTime(as_12));
   int l_minute_32 = TimeMinute(StrToTime(as_12));
   string ls_ret_36 = "no";
   if (ai_0) {
      if (l_hour_20 < l_hour_28) {
         if (Hour() >= l_hour_20 && Hour() <= l_hour_28) {
            ls_ret_36 = "yes";
            if (Hour() == l_hour_20 && Minute() < l_minute_24) ls_ret_36 = "no";
            if (Hour() == l_hour_28 && Minute() > l_minute_32) ls_ret_36 = "no";
         }
      }
      if (l_hour_20 > l_hour_28) {
         if (Hour() >= l_hour_20 || Hour() <= l_hour_28) {
            ls_ret_36 = "yes";
            if (Hour() == l_hour_20 && Minute() < l_minute_24) ls_ret_36 = "no";
            if (Hour() == l_hour_28 && Minute() > l_minute_32) ls_ret_36 = "no";
         }
      }
   }
   if (!ai_0) ls_ret_36 = "yes";
   return (ls_ret_36);
}

void WriteMABuy(int ai_0) {
   int l_file_4 = FileOpen((MagicNumber + Period()) + Symbol() + "MAX1Buy.dat", FILE_BIN|FILE_WRITE);
   if (l_file_4 < 1) {
      Print("cant open file error-", GetLastError());
      return;
   }
   FileWriteInteger(l_file_4, ai_0, LONG_VALUE);
   FileClose(l_file_4);
}

int ReadMABuy() {
   double ld_ret_4 = 0;
   int l_file_0 = FileOpen((MagicNumber + Period()) + Symbol() + "MAX1Buy.dat", FILE_BIN|FILE_READ);
   if (l_file_0 > 0) {
      ld_ret_4 = FileReadInteger(l_file_0, LONG_VALUE);
      FileClose(l_file_0);
   }
   return (ld_ret_4);
}

void WriteMASell(int ai_0) {
   int l_file_4 = FileOpen((MagicNumber + Period()) + Symbol() + "MAX1Sell.dat", FILE_BIN|FILE_WRITE);
   if (l_file_4 < 1) {
      Print("cant open file error-", GetLastError());
      return;
   }
   FileWriteInteger(l_file_4, ai_0, LONG_VALUE);
   FileClose(l_file_4);
}

int ReadMASell() {
   double ld_ret_4 = 0;
   int l_file_0 = FileOpen((MagicNumber + Period()) + Symbol() + "MAX1Sell.dat", FILE_BIN|FILE_READ);
   if (l_file_0 > 0) {
      ld_ret_4 = FileReadInteger(l_file_0, LONG_VALUE);
      FileClose(l_file_0);
   }
   return (ld_ret_4);
}